## hpklinux.spec
##
##    AudioScience HPI driver
##
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of version 2 of the GNU General Public License as
##    published by the Free Software Foundation;
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with this program; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place, Suite 330,
##    Boston, MA  02111-1307  USA
##

Summary: A Linux HPI Driver for AudioScience Audio Adapters
Name: hpklinux
Version: 4.20.10
Release: 1%{?dist}
License: GPL
Source: hpklinux_%{version}.tar.gz
Patch0: hpklinux-%{version}-1-disable-alsa-patch
BuildRoot: /var/tmp/hpklinux-%{version}
Conflicts: alsa-firmware
Requires: /sbin/chkconfig, /usr/sbin/depmod, /bin/rm, /bin/mv, /bin/mkdir
Requires: sh-utils
BuildRequires: %kernel_module_package_buildreqs

%package devel
Summary: Development files for AudioScience Audio Adapters
Requires: hpklinux

%description
HPI driver for the AudioScience line of professional audio adapters.

%description devel
Development files for the AudioScience HPI driver.

%pre
find /lib/modules -name asihpi.ko -exec rm \{\} \;

%post
if test -f /etc/init.d/rivendell ; then
    /etc/init.d/rivendell stop
fi
if test -f /usr/bin/rivendell ; then
    /usr/bin/rivendell stop
fi
for f in /lib/modules/*
do
  if test $f != /lib/modules/2.6.32-71.el6 ; then
    mkdir -p $f/weak-updates
    rm -f $f/weak-updates/asihpi.ko
    ln -s /lib/modules/2.6.32-71.el6/extra/asihpi.ko $f/weak-updates/asihpi.ko
  fi
done
/usr/sbin/depmod -a
/sbin/ldconfig
/sbin/modprobe asihpi
if test -f /etc/init.d/rivendell ; then
    /etc/init.d/rivendell start
fi

%preun
if test $1 -eq 0 ; then
  if test -f /etc/init.d/rivendell ; then
      /etc/init.d/rivendell stop
  fi
  if test -f /usr/bin/rivendell ; then
      /usr/bin/rivendell stop
  fi
  for f in /lib/modules/*
  do
    if test $f != /lib/modules/2.6.32-71.el6 ; then
      rm -f $f/weak-updates/asihpi.ko
    fi
  done
  if test -n "`grep -w asihpi /proc/modules`" ; then
    /sbin/rmmod -w asihpi
  fi
  if test -f /etc/init.d/rivendell ; then
    /etc/init.d/rivendell start
  fi
fi

%prep


%setup -n %{name}_%{version}
%patch0 -p1
##%patch1 -p1


%build
make -C hpi-drv
make -C hpi-lib
make -C hpi-cli-apps

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp hpi-cli-apps/asihpitest $RPM_BUILD_ROOT%{_bindir}
cp hpi-cli-apps/asihpirec $RPM_BUILD_ROOT%{_bindir}
cp hpi-cli-apps/asihpiplay $RPM_BUILD_ROOT%{_bindir}
cp hpi-cli-apps/asihpiassert $RPM_BUILD_ROOT%{_bindir}
cp hpi-cli-apps/asihpitune $RPM_BUILD_ROOT%{_bindir}
cp hpi-cli-apps/asi_firmware_updater $RPM_BUILD_ROOT%{_bindir}

##mkdir -p $RPM_BUILD_ROOT/tmp
##cp helpers/firmware.agent $RPM_BUILD_ROOT/tmp/firmware.agent

mkdir -p $RPM_BUILD_ROOT/lib/firmware/asihpi/4.20
#cp firmware/dsp5000.bin $RPM_BUILD_ROOT/lib/firmware/asihpi/4.20/
cp hpi-drv/firmware/dsp6200.bin $RPM_BUILD_ROOT/lib/firmware/asihpi/4.20/
cp hpi-drv/firmware/dsp6205.bin $RPM_BUILD_ROOT/lib/firmware/asihpi/4.20/
cp hpi-drv/firmware/dsp6400.bin $RPM_BUILD_ROOT/lib/firmware/asihpi/4.20/
cp hpi-drv/firmware/dsp6600.bin $RPM_BUILD_ROOT/lib/firmware/asihpi/4.20/
cp hpi-drv/firmware/dsp6780.bin $RPM_BUILD_ROOT/lib/firmware/asihpi/4.20/
cp hpi-drv/firmware/dsp6790.bin $RPM_BUILD_ROOT/lib/firmware/asihpi/4.20/
#cp hpi-drv/firmware/dsp8700.bin $RPM_BUILD_ROOT/lib/firmware/asihpi/4.20/
cp hpi-drv/firmware/dsp8900.bin $RPM_BUILD_ROOT/lib/firmware/asihpi/4.20/

mkdir -p $RPM_BUILD_ROOT/etc/modprobe.d
cp hpklinux.conf $RPM_BUILD_ROOT/etc/modprobe.d/

mkdir -p $RPM_BUILD_ROOT/etc/udev/rules.d
cp hpi-drv/asihpi.rules $RPM_BUILD_ROOT/etc/udev/rules.d/45-asihpi.rules

mkdir -p $RPM_BUILD_ROOT/lib/modules/2.6.32-71.el6/extra
cp hpi-drv/asihpi.ko $RPM_BUILD_ROOT/lib/modules/2.6.32-71.el6/extra

mkdir -p $RPM_BUILD_ROOT%{_includedir}/asihpi
cp hpi-lib/hpi.h $RPM_BUILD_ROOT%{_includedir}/asihpi
cp hpi-lib/hpi_version.h $RPM_BUILD_ROOT%{_includedir}/asihpi

mkdir -p $RPM_BUILD_ROOT%{_libdir}
cp hpi-lib/libhpi.a $RPM_BUILD_ROOT%{_libdir}
cp hpi-lib/libhpi.so.10.3.0 $RPM_BUILD_ROOT%{_libdir}
ln -s %{_libdir}/libhpi.so.10.3.0 $RPM_BUILD_ROOT%{_libdir}/libhpi.so
ln -s %{_libdir}/libhpi.so.10.3.0 $RPM_BUILD_ROOT%{_libdir}/libhpi.so.10

cp hpi-lib/libhpiudp.a $RPM_BUILD_ROOT%{_libdir}
cp hpi-lib/libhpiudp.so.10.3.0 $RPM_BUILD_ROOT%{_libdir}
ln -s %{_libdir}/libhpiudp.so.10.3.0 $RPM_BUILD_ROOT%{_libdir}/libhpiudp.so
ln -s %{_libdir}/libhpiudp.so.10.3.0 $RPM_BUILD_ROOT%{_libdir}/libhpiudp.so.10

cp hpi-lib/libhpimux.a $RPM_BUILD_ROOT%{_libdir}
cp hpi-lib/libhpimux.so.10.3.0 $RPM_BUILD_ROOT%{_libdir}
ln -s %{_libdir}/libhpimux.so.10.3.0 $RPM_BUILD_ROOT%{_libdir}/libhpimux.so
ln -s %{_libdir}/libhpimux.so.10.3.0 $RPM_BUILD_ROOT%{_libdir}/libhpimux.so.10

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root)
%{_bindir}/asihpitest
%{_bindir}/asihpirec
%{_bindir}/asihpiplay
%{_bindir}/asihpiassert
%{_bindir}/asihpitune
%{_bindir}/asi_firmware_updater
#/lib/firmware/asihpi/4.20/dsp5000.bin
/lib/firmware/asihpi/4.20/dsp6200.bin
/lib/firmware/asihpi/4.20/dsp6205.bin
/lib/firmware/asihpi/4.20/dsp6400.bin
/lib/firmware/asihpi/4.20/dsp6600.bin
/lib/firmware/asihpi/4.20/dsp6780.bin
/lib/firmware/asihpi/4.20/dsp6790.bin
#/lib/firmware/asihpi/4.20/dsp8700.bin
/lib/firmware/asihpi/4.20/dsp8900.bin
/etc/modprobe.d/hpklinux.conf
/etc/udev/rules.d/45-asihpi.rules
/lib/modules/2.6.32-71.el6/extra/asihpi.ko
%{_libdir}/libhpi.so.10.3.0
%{_libdir}/libhpi.so
%{_libdir}/libhpi.so.10
%{_libdir}/libhpiudp.so.10.3.0
%{_libdir}/libhpiudp.so
%{_libdir}/libhpiudp.so.10
%{_libdir}/libhpimux.so.10.3.0
%{_libdir}/libhpimux.so
%{_libdir}/libhpimux.so.10

#%doc drvnotes.txt README.hpi INSTALL.hpi

%files devel
%{_includedir}/asihpi/hpi.h
%{_includedir}/asihpi/hpi_version.h
%{_libdir}/libhpi.a
%{_libdir}/libhpiudp.a
%{_libdir}/libhpimux.a

%changelog
* Thu Mar  1 2018 Fred Gleason <fredg@paravelsystems.com> - 4.20.08-1
-- Updated for v4.20.08
* Wed Jul 13 2016 Fred Gleason <fredg@paravelsystems.com> - 4.18.03-1
-- Updated for v4.18.03
* Mon Nov 23 2015 Fred Gleason <fredg@paravelsystems.com> - 4.14.07-1
-- Updated for v4.14.07
* Sun Aug 17 2014 Fred Gleason <fredg@paravelsystems.com> - 4.13.00-2
-- Changed the path to depmod(8) from '/sbin/depmod' to '/usr/sbin/depmod'.
* Wed Aug 13 2014 Fred Gleason <fredg@paravelsystems.com> - 4.13.00-1
-- Updated for 4.13.00-01.
* Mon Sep 10 2012 Fred Gleason <fredg@paravelsystems.com> - 4.10.09-9
-- Fixed pre-uninstallation script to remove module symlinks only if
complete package removal has been specified.
* Fri Sep 07 2012 Fred Gleason <fredg@paravelsystems.com> - 4.10.09-7
-- Modified 'dev/asihpi.rules'.
* Fri Sep 07 2012 Fred Gleason <fredg@paravelsystems.com> - 4.10.09-6
-- Added code to restart Rivendell.
* Thu Sep 06 2012 Fred Gleason <fredg@paravelsystems.com>
-- Fixed post-installation script to update module dependencies correctly.
* Thu May 03 2012 Fred Gleason <fredg@paravelsystems.com>
-- Modfied for CentOS 6.
* Wed May 05 2010 Fred Gleason <fredg@paravelsystems.com>
-- Removed 'asihpi' init script.
-- Added a modprobe(8) call to initialize driver after installation.
-- Added a 'Conflicts:' rule for 'alsa-firmware'.
* Thu Apr 29 2010 Fred Gleason <fredg@paravelsystems.com>
-- Removed drvnotes_rc.txt.
* Fri May 23 2008 Eliot Blennerhassett <eblennerhassett@audioscience.com>
-- Change firmware names. Remove ASI4xxx firmware
* Wed Sep 26 2007 Eliot Blennerhassett <eblennerhassett@audioscience.com>
-- Add udev rule, remove asihpi script from bin
* Wed Jun 06 2007 Eliot Blennerhassett <eblennerhassett@audioscience.com>
-- Restructure directories. Remove firmware.agent install
* Fri Aug 11 2006 Fred Gleason <fredg@salemradiolabs.com>
-- Added conditional library path to support x86_64 architecture.
* Tue May 16 2006 Eliot Blennerhassett <eblennerhassett@audioscience.com>
-- Remove DSP support for 4[456]00, 8800, add 6600
* Fri Mar 17 2006 Fred Gleason <fredg@salemradiolabs.com>
-- Fixed the library versioning to automatically track changes.
* Fri Feb 10 2006 Eliot Blennerhassett <eblennerhassett@audioscience.com>
-- Alter dsp bin install to use DSPBINPATH from Autoconf
* Wed Feb 08 2006 Fred Gleason <fredg@salemradiolabs.com>
-- Altered install paths to use $prefix value from Autoconf.
* Thu May 19 2005 Eliot Blennerhassett <eblennerhassett@audioscience.com>
-- add dsp6205, remove dsp8705
* Thu Jan 27 2005 Eliot Blennerhassett <eblennnerhassett@audioscience.com>
-- fixed install paths for test software
* Mon Jan 17 2005 Eliot Blennerhassett <eblennerhassett@audioscience.com>
-- added asihpitune
* Wed Aug 18 2004 Fred Gleason <fredg@salemradiolabs.com>
-- Corrected for proper module path/name on both 2.4.x and 2.6.x kernels.
* Thu Aug 05 2004 Fred Gleason <fredg@salemradiolabs.com>
-- Added 'depmod -a' to %post.
-- Added a rule to install '/etc/hotplug/firmware.agent' if needed.
* Tue Aug 03 2004 Fred Gleason <fredg@salemradiolabs.com>
-- Modified for new firmware layout.
-- Modified to support dynamic library binaries.
-- Added a 'devel' subpackage.
* Thu Mar 04 2004 EB
-- Fixed date typo below. Fix path to INSTALL.hpi
* Wed Feb 04 2004 Eliot Blennerhassett <eblennerhassett@audioscience.com>
-- Removed asihpiload and asihpiunload, added thpilinux,hpiassert
* Tue Feb 03 2004 Fred Gleason <fredg@salemradiolabs.com>
-- Changed autosubstitution of kernel version to use AC_SUBST macro
rather than sed(1).
* Mon Dec 01 2003 Fred Gleason <fredg@salemradiolabs.com>
-- Added spec file to the base HPK source tree as part of the
project to autoconfiscate the driver.
* Mon Dec 02 2002 Fred Gleason <fredg@wava.com>
- Updated for SuSE 8.0/SMP and HPK v2.74.
* Wed Oct 30 2002 Fred Gleason <fredg@wava.com>
- Updated for SuSE 8.1 and HPK v2.73.
* Fri Sep 27 2002 Fred Gleason <fredg@wava.com>
- Initial package creation.
